#ifndef INCLUDED_ESDOM_ESDOMException_hpp
#define INCLUDED_ESDOM_ESDOMException_hpp

namespace ESDOM
{

class ESDOM_EXPORT ESDOMException
{
public:
	ESDOMException();
	ESDOMException(const ESDOMException &original);
	ESDOMException(unsigned short Code);
	virtual ~ESDOMException();

	enum ExceptionCode
	{
		INDEX_SIZE_ERR				= 1,
		DOMSTRING_SIZE_ERR			= 2,
		HIERARCHY_REQUEST_ERR		= 3,
		WRONG_DOCUMENT_ERR			= 4,
		INVALID_CHARACTER_ERR		= 5,
		NO_DATA_ALLOWED_ERR			= 6,
		NO_MODIFICATION_ALLOWED_ERR	= 7,
		NOT_FOUND_ERR				= 8,
		NOT_SUPPORTED_ERR			= 9,
		INUSE_ATTRIBUTE_ERR			= 10,
		INVALID_STATE_ERR			= 11,
	    SYNTAX_ERR					= 12,
        INVALID_MODIFICATION_ERR	= 13,
        NAMESPACE_ERR				= 14,
        INVALID_ACCESS_ERR			= 15,

		UNINITIALIZED				= 100,
		OUT_OF_MEMORY				= 101,
		NULL_OBJECT					= 102,
		BAD_CAST					= 103,
		METHOD_IS_NOT_MEMBER		= 104
	};

	unsigned short	code;
};

}; /* namespace ESDOM */

#endif /* INCLUDED_ESDOM_ESDOMException_hpp */
