#ifndef INCLUDED_ESDOM_WIN32_hpp
#define INCLUDED_ESDOM_WIN32_hpp

#include <windows.h>

extern "C" __declspec(dllexport) DWORD GetDllVersion(void);

namespace ESDOM
{

typedef HANDLE ESDOM_FILE;

inline bool ESDOM_isRegFile(ESDOM_FILE FileHandle)
{
	return ( GetFileType(FileHandle) == FILE_TYPE_DISK );
}

inline bool ESDOM_seek(ESDOM_FILE FileHandle,long offset, long whence)
{
	DWORD dwMoveMethod ;
	if( whence == FILE_SEEK_SET )
		dwMoveMethod = FILE_BEGIN;
	else if( whence == FILE_SEEK_CUR )
		dwMoveMethod = FILE_CURRENT;
	else if( whence == FILE_SEEK_END )
		dwMoveMethod = FILE_END;
	else
		return false;
	if( SetFilePointer(FileHandle, offset, 0, dwMoveMethod) == (DWORD)(-1) )
		return false;
	return true;
}

inline long ESDOM_tell(ESDOM_FILE FileHandle)
{
	return SetFilePointer(FileHandle, 0, 0, FILE_CURRENT);
}

inline bool ESDOM_truncate(ESDOM_FILE FileHandle)
{
	return SetEndOfFile(FileHandle) ? true : false;
}

inline unsigned long readFromFile(ESDOM_FILE FileHandle, unsigned char *buffer, unsigned long size)
{
	DWORD dwResult;
	ReadFile(FileHandle, buffer, size, &dwResult, NULL);
	return dwResult;
}

inline unsigned long writeToFile(ESDOM_FILE FileHandle, const unsigned char *buffer, unsigned long size)
{
	DWORD dwResult;
	WriteFile(FileHandle, buffer, size, &dwResult, NULL);
	return dwResult;
}

}; /* namespace ESODM */

#endif /* INCLUDED_ESDOM_WIN32_hpp */
