#include <ESDOM/ESDOM_define.hpp>
#include <ESDOM/API.hpp>
#include <ESDOM/ESDOMString.hpp>
#include <ESDOM/Initializer.hpp>
#include <ESDOM/Document.hpp>
#include "Parser.hpp"
#include "Serializer.hpp"
#include "Instance.hpp"

using namespace ESDOM;

const ESDOM_CHAR	ESDOM::ESDOM_NULL_STRING[2] = {0,0};

ESDOM_EXPORT ESDOMString	ESDOM::m_errorMessage;


#ifdef ESDOM_DEBUG
ESDOM_EXPORT unsigned long ESDOM::getTotalInstanceNum(void)
{
	return Instance::m_gTotalInstanceNum;
}
#endif


ESDOM_EXPORT bool ESDOM::initialize(unsigned long NodeListPageSize,
								   unsigned long NamedNodeMapHashTableSize,
								   unsigned long ESDOMStringPageSize)
{
	return Initializer::initialize( NodeListPageSize, NamedNodeMapHashTableSize, ESDOMStringPageSize );
}

ESDOM_EXPORT Document ESDOM::createDocument(const ESDOM_CHAR *version,
										   const ESDOM_CHAR *rootTagName,
										   const ESDOM_CHAR *docutype)
{
	return Document::_createNewDocument( version, rootTagName, docutype );
}

ESDOM_EXPORT Document ESDOM::parse(ESDOM_FILE FileHandle)
{
	Parser	parser;
	return parser.parse(FileHandle);
}

ESDOM_EXPORT bool ESDOM::serialize(const Document &document, unsigned short encoding, ESDOM_FILE FileHandle)
{
	Serializer	serializer;
	return serializer.serialize( document, encoding, FileHandle );
}

