#include <ESDOM/ESDOM_define.hpp>
#include <ESDOM/ESDOMException.hpp>
#include "AttrInst.hpp"
#include <ESDOM/Node.hpp>

using namespace ESDOM;

AttrInst::AttrInst( const ESDOM_CHAR *name )
 : NodeInst( name, Node::ATTRIBUTE_NODE, false, false )
{
	m_ownerElement = 0;
}

AttrInst::AttrInst( const AttrInst &original )
 : NodeInst( original )
{
	m_ownerElement = 0;
}

AttrInst::~AttrInst()
{
}

NodeInst * AttrInst::cloneNodeInst(bool deep) const
{
	AttrInst *newNodeInst;
	try{
		newNodeInst = new AttrInst(*this); if(!newNodeInst)throw 0;
	}catch(...){
		throw ESDOMException( ESDOMException::OUT_OF_MEMORY );
	}

	return newNodeInst;
}

ElementInst * AttrInst::getOwnerElement() const
{
	return m_ownerElement;
}
