#ifndef INCLUDED_ESDOM_ESDOMStringInst_hpp
#define INCLUDED_ESDOM_ESDOMStringInst_hpp

namespace ESDOM
{

class ESDOM_EXPORT ESDOMStringInst
{
protected:
	explicit ESDOMStringInst(unsigned long length);
	explicit ESDOMStringInst(const ESDOM_CHAR *string);
	explicit ESDOMStringInst(const char *string);
	~ESDOMStringInst();

	void			addRef(void) const;
	void			removeRef(void) const;
	unsigned long	getRefCount(void) const;
	void			operator += (const ESDOM_CHAR *string);
	void			operator += (const char *string);
	void			operator += (ESDOM_CHAR ch);

	ESDOM_CHAR				*m_data;
	unsigned long			m_length;
	static	unsigned long	PAGE_SIZE;

	friend	class	ESDOMString;
	friend	class	Initializer;

	friend bool ESDOM_EXPORT	operator == (const ESDOM_CHAR *ls,	const ESDOMString &rs);
	friend bool ESDOM_EXPORT	operator == (const char *ls,		const ESDOMString &rs);
	friend bool ESDOM_EXPORT	operator == (ESDOM_CHAR lch,		const ESDOMString &rs);
	friend bool ESDOM_EXPORT	operator == (int ln,				const ESDOMString &rs);
	friend bool ESDOM_EXPORT	operator == (unsigned ln,			const ESDOMString &rs);
	friend bool ESDOM_EXPORT	operator != (const ESDOM_CHAR *ls,	const ESDOMString &rs);
	friend bool ESDOM_EXPORT	operator != (const char *ls,		const ESDOMString &rs);
	friend bool ESDOM_EXPORT	operator != (ESDOM_CHAR lch,		const ESDOMString &rs);
	friend bool ESDOM_EXPORT	operator != (int ln,				const ESDOMString &rs);
	friend bool ESDOM_EXPORT	operator != (unsigned ln,			const ESDOMString &rs);

private:
	mutable unsigned long	m_refCount;

	ESDOM_CHAR *	_allocate( unsigned long length );
};

}; /* namespace ESDOM */

#endif /* INCLUDED_ESDOM_ESDOMStringInst_hpp */
