#include <ESDOM/ESDOM_define.hpp>
#include <ESDOM/API.hpp>
#include <ESDOM/Initializer.hpp>
#include <ESDOM/ESDOMString.hpp>
#include "ESDOMStringInst.hpp"
#include "NodeListInst.hpp"
#include "NamedNodeMapInst.hpp"

using namespace ESDOM;

bool Initializer::m_initialized = false;

bool Initializer::initialize(unsigned long NodeListPageSize,
							 unsigned long NamedNodeMapHashTableSize,
							 unsigned long ESDOMStringPageSize)
{
	if( !NodeListPageSize || !NamedNodeMapHashTableSize || !ESDOMStringPageSize || m_initialized )
		return false;

	clearLastError();

	NodeListInst::ITEMS_PAR_UNIT = NodeListPageSize;
	NamedNodeMapInst::TABLE_SIZE = NamedNodeMapHashTableSize;
	ESDOMStringInst::PAGE_SIZE = ESDOMStringPageSize;

	m_initialized = true;
	return true;
}
