#include <ESDOM/ESDOM_define.hpp>
#include <ESDOM/Interface.hpp>
#include "Instance.hpp"

using namespace ESDOM;

Interface::Interface()
{
	m_instance = 0;
}

Interface::Interface(const Interface &original)
{
	m_instance = original.m_instance;
	if ( m_instance )
		m_instance->addRef();
}

Interface::Interface(const Instance *instance)
{
	m_instance = instance;
	if( m_instance )
		m_instance->addRef();
}

Interface::~Interface()
{
	if( m_instance )
		m_instance->removeRef();
}

Interface & Interface::operator = (const Interface &newInterface)
{
	if( m_instance )
		m_instance->removeRef();
	
	m_instance = newInterface.m_instance;
	if( m_instance )
		m_instance->addRef();
	return *this;
}
bool Interface::operator == (const Interface &other) const
{
	return ( m_instance == other.m_instance );
}

bool Interface::operator != (const Interface &other) const
{
	return ( m_instance != other.m_instance );
}

Interface::operator bool () const
{
	return m_instance ? true : false;
}
