#include <ESDOM/ESDOM_define.hpp>
#include "NodeListInst.hpp"
#include <ESDOM/NodeList.hpp>
#include <ESDOM/Node.hpp>

using namespace ESDOM;

NodeList::NodeList()
{
}

NodeList::NodeList(const NodeList &original)
 : Interface(original)
{
}

NodeList::NodeList(const NodeListInst *nodeListInst)
 : Interface(nodeListInst)
{
}

NodeList::~NodeList()
{
}

NodeList & NodeList::operator = (const NodeList &newNodeList)
{
	Interface::operator = (newNodeList);
	return *this;
}

Node NodeList::item(unsigned long index) const
{
	if( !m_instance )
		throw ESDOMException(ESDOMException::NULL_OBJECT);
	return Node( ((NodeListInst*)m_instance)->item(index) );
}

unsigned long NodeList::getLength() const
{
	if( !m_instance )
		throw ESDOMException(ESDOMException::NULL_OBJECT);
	return ((NodeListInst*)m_instance)->getLength();
}
