#ifndef INCLUDED_ESDOM_NodeListInst_hpp
#define INCLUDED_ESDOM_NodeListInst_hpp

#include "Instance.hpp"
#include "ESDOM_vector.hpp"


namespace ESDOM
{

class ESDOM_EXPORT NodeInst;

#ifdef NEED_EXPLICIT_INSTANTIATION
template class ESDOM_EXPORT vector<NodeInst**>;
#endif

class ESDOM_EXPORT NodeListInst : public Instance
{

public:
	explicit NodeListInst();
	~NodeListInst();
	
	NodeInst *		item(unsigned long index) const;
	unsigned long	getLength(void) const;
	NodeListInst *	clone(bool duplicateNode) const;
	bool			appendNode(const NodeInst *newNodeInst);
	bool			insertNode(const NodeInst *newNodeInst, const NodeInst *refNodeInst);
	bool			removeNode(const NodeInst *oldNodeInst);
	bool			replaceNode(const NodeInst *newNode, const NodeInst *oldNode);

protected:
	explicit NodeListInst(const NodeListInst &original);
	explicit NodeListInst(const NodeListInst &original, bool duplicateNode);

	static unsigned long ITEMS_PAR_UNIT;

	friend	class	Initializer;

private:
	vector<NodeInst**> m_page;
	unsigned long	m_length;
	inline NodeInst ** _allocate();
};

}; /* namespace ESDOM */

#endif /* INCLUDED_ESDOM_NodeListInst_hpp */
