#ifndef INCLUDED_ESDOM_Serialize_hpp
#define INCLUDED_ESDOM_Serialize_hpp

#include <ESDOM/ESDOM_define.hpp>
#include <ESDOM/API.hpp>
#include <ESDOM/Document.hpp>

namespace ESDOM
{

class ESDOM_EXPORT Element;
class ESDOM_EXPORT ProcessingInstruction;
class ESDOM_EXPORT Comment;
class ESDOM_EXPORT Text;
class ESDOM_EXPORT CDATASection;
class ESDOM_EXPORT Document;

class ESDOM_EXPORT Serializer
{
public:
	bool			serialize(const Document &docment, unsigned short encoding, ESDOM_FILE FileHandle);
//	unsigned char *	serializeToBuffer(const Document &docment, unsigned short encoding);

	bool		serialize();
	void		serializeElement(const Element &element, bool fHTML);
	ESDOMString	char2entityReference(const ESDOMString &string, bool fHTML);

	void	writeChars(const ESDOM_CHAR *string, unsigned long length);
	void	writeChars(const ESDOM_CHAR *string)
					{writeChars(string, strlen(string));}
	void	writeChars(const ESDOMString &string)
					{writeChars(string, string.getLength());}
	void	write(unsigned char *buffer, unsigned long size);
private:
	Document		m_document;
	void *			m_dst;
	unsigned short	m_encoding;
};

}; /* namespace ESDOM */

#endif /* INCLUDED_ESDOM_Serialize_hpp */
